Index: lib/libpcap/Makefile
===================================================================
RCS file: /home/dcvs/src/lib/libpcap/Makefile,v
retrieving revision 1.8
diff -u -r1.8 Makefile
--- lib/libpcap/Makefile	7 Jul 2005 11:49:55 -0000	1.8
+++ lib/libpcap/Makefile	18 Dec 2006 00:06:11 -0000
@@ -13,6 +13,7 @@
 
 CFLAGS+=-DHAVE_CONFIG_H -Dyylval=pcap_lval -I${.CURDIR} -I.
 CFLAGS+=-D_U_="__attribute__((unused))"
+CFLAGS+=-DHAVE_STRUCT_ETHER_ADDR
 .if !defined(NOINET6)
 CFLAGS+=-DINET6
 .endif
@@ -22,7 +23,7 @@
 #
 # Magic to grab sources out of src/contrib
 #
-PCAP_DISTDIR?=${.CURDIR}/../../contrib/libpcap-0.8.3
+PCAP_DISTDIR?=${.CURDIR}/../../contrib/libpcap-0.9
 CFLAGS+=-I${PCAP_DISTDIR}
 .PATH:	${PCAP_DISTDIR}
 .PATH:	${PCAP_DISTDIR}/bpf/net
@@ -39,10 +40,4 @@
 tokdefs.h: grammar.h
 	${LN} -sf grammar.h tokdefs.h
 
-#
-# Apply patches
-#
-CONTRIBDIR=${PCAP_DISTDIR}
-SRCS+=nametoaddr.c.patch
-
 .include <bsd.lib.mk>
Index: lib/libpcap/config.h
===================================================================
RCS file: /home/dcvs/src/lib/libpcap/config.h,v
retrieving revision 1.3
diff -u -r1.3 config.h
--- lib/libpcap/config.h	15 May 2004 12:28:33 -0000	1.3
+++ lib/libpcap/config.h	18 Dec 2006 00:03:20 -0000
@@ -1,13 +1,6 @@
-/* $FreeBSD: src/lib/libpcap/config.h,v 1.1.2.2 2002/07/05 14:40:00 fenner Exp $ */
-/* $DragonFly: src/lib/libpcap/config.h,v 1.3 2004/05/15 12:28:33 eirikn Exp $ */
-/* This is an edited copy of the config.h generated by configure. */
-
-/* config.h.  Generated automatically by configure.  */
-/* config.h.in.  Generated automatically from configure.in by autoheader.  */
-
-/* Define as __inline if that's what the C compiler calls it.  */
-/* #undef inline */
-
+/* $DragonFly$ */
+/* config.h.  Generated by configure.  */
+/* config.h.in.  Generated from configure.in by autoheader.  */
 /* Long story short: aclocal.m4 depends on autoconf 2.13
  * implementation details wrt "const"; newer versions
  * have different implementation details so for now we
@@ -16,106 +9,183 @@
  */
 /* #undef const */
 
-/* Define if you have the ether_hostton function.  */
-#define HAVE_ETHER_HOSTTON 1
+/* Enable optimizer debugging */
+/* #undef BDEBUG */
 
-/* Define if you have the snprintf function.  */
-#define HAVE_SNPRINTF 1
+/* define if you have the DAG API */
+/* #undef HAVE_DAG_API */
 
-/* Define if you have the strerror function.  */
-#define HAVE_STRERROR 1
+/* define if you have dag_get_erf_types() */
+/* #undef HAVE_DAG_GET_ERF_TYPES */
 
-/* Define if you have the strlcpy function.  */
-#define HAVE_STRLCPY 1
+/* define if you have streams capable DAG API */
+/* #undef HAVE_DAG_STREAMS_API */
 
-/* Define if you have the vsnprintf function.  */
-#define HAVE_VSNPRINTF 1
+/* Define to 1 if you have the declaration of `ether_hostton', and to 0 if you
+   don't. */
+#define HAVE_DECL_ETHER_HOSTTON 1
 
-/* Define if you have the <ifaddrs.h> header file.  */
-#define HAVE_IFADDRS_H 1
+/* define if you have a /dev/dlpi */
+/* #undef HAVE_DEV_DLPI */
+
+/* Define to 1 if you have the `ether_hostton' function. */
+#define HAVE_ETHER_HOSTTON 1
 
-/* Define if you have the <limits.h> header file.  */
+/* on HP-UX 10.20 or later */
+/* #undef HAVE_HPUX10_20_OR_LATER */
+
+/* on HP-UX 9.x */
+/* #undef HAVE_HPUX9 */
+
+/* if ppa_info_t_dl_module_id exists */
+/* #undef HAVE_HP_PPA_INFO_T_DL_MODULE_ID_1 */
+
+/* Define to 1 if you have the <inttypes.h> header file. */
+#define HAVE_INTTYPES_H 1
+
+/* Define to 1 if you have the <limits.h> header file. */
 #define HAVE_LIMITS_H 1
 
-/* Define if you have the <netinet/if_ether.h> header file.  */
+/* Define to 1 if you have the <memory.h> header file. */
+#define HAVE_MEMORY_H 1
+
+/* Define to 1 if you have the <netinet/ether.h> header file. */
+/* #undef HAVE_NETINET_ETHER_H */
+
+/* Define to 1 if you have the <netinet/if_ether.h> header file. */
 #define HAVE_NETINET_IF_ETHER_H 1
 
-/* Define if you have the <sys/bufmod.h> header file.  */
+/* if there's an os_proto.h */
+/* #undef HAVE_OS_PROTO_H */
+
+/* define if you have a /proc/net/dev */
+/* #undef HAVE_PROC_NET_DEV */
+
+/* define if you have a Septel API */
+/* #undef HAVE_SEPTEL_API */
+
+/* Define to 1 if you have the `snprintf' function. */
+#define HAVE_SNPRINTF 1
+
+/* if struct sockaddr has sa_len */
+#define HAVE_SOCKADDR_SA_LEN 1
+
+/* if struct sockaddr_storage exists */
+#define HAVE_SOCKADDR_STORAGE 1
+
+/* On solaris */
+/* #undef HAVE_SOLARIS */
+
+/* Define to 1 if you have the <stdint.h> header file. */
+#define HAVE_STDINT_H 1
+
+/* Define to 1 if you have the <stdlib.h> header file. */
+#define HAVE_STDLIB_H 1
+
+/* Define to 1 if you have the `strerror' function. */
+#define HAVE_STRERROR 1
+
+/* Define to 1 if you have the <strings.h> header file. */
+#define HAVE_STRINGS_H 1
+
+/* Define to 1 if you have the <string.h> header file. */
+#define HAVE_STRING_H 1
+
+/* Define to 1 if you have the `strlcpy' function. */
+#define HAVE_STRLCPY 1
+
+/* Define to 1 if the system has the type `struct ether_addr'. */
+/* #undef HAVE_STRUCT_ETHER_ADDR */
+
+/* Define to 1 if you have the <sys/bufmod.h> header file. */
 /* #undef HAVE_SYS_BUFMOD_H */
 
-/* Define if you have the <sys/dlpi_ext.h> header file.  */
+/* Define to 1 if you have the <sys/dlpi_ext.h> header file. */
 /* #undef HAVE_SYS_DLPI_EXT_H */
 
-/* Define if you have the <sys/ioccom.h> header file.  */
+/* Define to 1 if you have the <sys/ioccom.h> header file. */
 #define HAVE_SYS_IOCCOM_H 1
 
-/* Define if you have the <sys/sockio.h> header file.  */
+/* Define to 1 if you have the <sys/sockio.h> header file. */
 #define HAVE_SYS_SOCKIO_H 1
 
-/* needed on HP-UX */
-/* #undef _HPUX_SOURCE */
+/* Define to 1 if you have the <sys/stat.h> header file. */
+#define HAVE_SYS_STAT_H 1
+
+/* Define to 1 if you have the <sys/types.h> header file. */
+#define HAVE_SYS_TYPES_H 1
+
+/* if if_packet.h has tpacket_stats defined */
+/* #undef HAVE_TPACKET_STATS */
+
+/* Define to 1 if you have the <unistd.h> header file. */
+#define HAVE_UNISTD_H 1
+
+/* define if version.h is generated in the build procedure */
+#define HAVE_VERSION_H 1
+
+/* Define to 1 if you have the `vsnprintf' function. */
+#define HAVE_VSNPRINTF 1
 
 /* define if your compiler has __attribute__ */
 #define HAVE___ATTRIBUTE__ 1
 
-/* if we have u_int8_t */
-/* #undef u_int8_t */
+/* IPv6 */
+/* #undef INET6 */
 
-/* if we have u_int16_t */
-/* #undef u_int16_t */
+/* if unaligned access fails */
+/* #undef LBL_ALIGN */
 
-/* if we have u_int32_t */
-/* #undef u_int32_t */
+/* Define to 1 if netinet/ether.h declares `ether_hostton' */
+/* #undef NETINET_ETHER_H_DECLARES_ETHER_HOSTTON */
+
+/* Define to 1 if netinet/if_ether.h declares `ether_hostton' */
+#define NETINET_IF_ETHER_H_DECLARES_ETHER_HOSTTON 
 
 /* do not use protochain */
 /* #undef NO_PROTOCHAIN */
 
-/* IPv6 */
-/* Handled by Makefile, to handle NOINET6 */
-/* #define INET6 1 */
+/* Define to the address where bug reports for this package should be sent. */
+#define PACKAGE_BUGREPORT ""
 
-/* Enable optimizer debugging */
-/* #undef BDEBUG */
+/* Define to the full name of this package. */
+#define PACKAGE_NAME ""
 
-/* Enable parser debugging */
-/* #undef YYDEBUG */
+/* Define to the full name and version of this package. */
+#define PACKAGE_STRING ""
 
-/* define if you have a /dev/dlpi */
-/* #undef HAVE_DEV_DLPI */
+/* Define to the one symbol short name of this package. */
+#define PACKAGE_TARNAME ""
+
+/* Define to the version of this package. */
+#define PACKAGE_VERSION ""
 
 /* /dev/dlpi directory */
 /* #undef PCAP_DEV_PREFIX */
 
-/* if if_packet.h has tpacket_stats defined */
-/* #undef HAVE_TPACKET_STATS */
+/* Define to 1 if you have the ANSI C header files. */
+#define STDC_HEADERS 1
 
-/* define if you have a /proc/net/dev */
-/* #undef HAVE_PROC_NET_DEV */
+/* Enable parser debugging */
+/* #undef YYDEBUG */
+
+/* needed on HP-UX */
+/* #undef _HPUX_SOURCE */
 
 /* define on AIX to get certain functions */
 /* #undef _SUN */
 
-/* on HP-UX 9.x */
-/* #undef HAVE_HPUX9 */
-
-/* on HP-UX 10.20 */
-/* #undef HAVE_HPUX10_20 */
+/* Define as token for inline if inlining supported */
+#define inline inline
 
 /* on sinix */
 /* #undef sinix */
 
-/* On solaris */
-/* #undef HAVE_SOLARIS */
-
-/* if there's an os_proto.h */
-/* #undef HAVE_OS_PROTO_H */
-
-/* if struct sockaddr has sa_len */
-#define HAVE_SOCKADDR_SA_LEN 1
-
-/* if ppa_info_t_dl_module_id exists */
-/* #undef HAVE_HP_PPA_INFO_T_DL_MODULE_ID_1 */
+/* if we have u_int16_t */
+/* #undef u_int16_t */
 
-/* if unaligned access fails */
-/* #undef LBL_ALIGN */
+/* if we have u_int32_t */
+/* #undef u_int32_t */
 
+/* if we have u_int8_t */
+/* #undef u_int8_t */
Index: lib/libpcap/nametoaddr.c.patch
===================================================================
RCS file: lib/libpcap/nametoaddr.c.patch
diff -N lib/libpcap/nametoaddr.c.patch
--- lib/libpcap/nametoaddr.c.patch	23 Jul 2004 13:03:20 -0000	1.1
+++ /dev/null	1 Jan 1970 00:00:00 -0000
@@ -1,12 +0,0 @@
-$DragonFly: src/lib/libpcap/nametoaddr.c.patch,v 1.1 2004/07/23 13:03:20 eirikn Exp $
---- nametoaddr.c.orig	2004-07-23 14:56:23.000000000 +0000
-+++ nametoaddr.c	2004-07-23 14:56:38.000000000 +0000
-@@ -391,7 +391,7 @@
-  */
- #if !defined(sgi) && !defined(__NetBSD__) && !defined(__FreeBSD__) && \
-        !defined(_UNICOSMP)
--extern int ether_hostton(char *, struct ether_addr *);
-+extern int ether_hostton(const char *, struct ether_addr *);
- #endif
- 
- /* Use the os supplied routines */