Index: usr.sbin/tcpdump/tcpdump/Makefile
===================================================================
RCS file: /home/dcvs/src/usr.sbin/tcpdump/tcpdump/Makefile,v
retrieving revision 1.6
diff -u -r1.6 Makefile
--- usr.sbin/tcpdump/tcpdump/Makefile	18 Jan 2006 02:33:38 -0000	1.6
+++ usr.sbin/tcpdump/tcpdump/Makefile	18 Dec 2006 05:13:32 -0000
@@ -2,37 +2,43 @@
 # $DragonFly: src/usr.sbin/tcpdump/tcpdump/Makefile,v 1.6 2006/01/18 02:33:38 dillon Exp $
 
 
-TCPDUMP_DISTDIR?= ${.CURDIR}/../../../contrib/tcpdump-3.8.3
+TCPDUMP_DISTDIR?= ${.CURDIR}/../../../contrib/tcpdump-3.9
 .PATH: ${TCPDUMP_DISTDIR}
 
 PROG=	tcpdump
-SRCS=	addrtoname.c gmpls.c gmt2local.c machdep.c \
-	oui.c parsenfsfh.c print-802_11.c print-ap1394.c \
-	print-ah.c print-arcnet.c print-aodv.c print-arp.c \
-	print-ascii.c print-atalk.c print-atm.c print-beep.c \
-	print-bfd.c print-bgp.c print-bootp.c print-cdp.c \
-	print-chdlc.c print-cip.c print-cnfp.c print-decnet.c \
+SRCS=	addrtoname.c cpack.c gmpls.c oui.c gmt2local.c ipproto.c \
+	nlpid.c l2vpn.c machdep.c parsenfsfh.c \
+	print-802_11.c print-ap1394.c print-ah.c print-arcnet.c \
+	print-aodv.c print-arp.c print-ascii.c print-atalk.c print-atm.c \
+	print-beep.c print-bfd.c print-bgp.c print-bootp.c print-cdp.c \
+	print-chdlc.c print-cip.c print-cnfp.c print-dccp.c print-decnet.c \
 	print-domain.c print-dvmrp.c print-enc.c print-egp.c \
+	print-eap.c print-eigrp.c \
 	print-esp.c print-ether.c print-fddi.c print-fr.c \
 	print-gre.c print-hsrp.c print-icmp.c print-igmp.c \
 	print-igrp.c print-ip.c print-ipcomp.c print-ipfc.c \
-	print-ipx.c print-isakmp.c print-isoclns.c print-krb.c \
+	print-ipx.c print-isakmp.c print-isoclns.c print-juniper.c print-krb.c \
 	print-l2tp.c print-lane.c print-ldp.c print-llc.c \
+	print-lmp.c print-lspping.c \
 	print-lwres.c print-mobile.c print-mpls.c print-msdp.c \
 	print-nfs.c print-ntp.c print-null.c print-ospf.c \
-	print-pflog.c print-pim.c print-ppp.c print-pppoe.c \
+	print-pflog.c print-pgm.c print-pim.c print-ppp.c print-pppoe.c \
 	print-pptp.c print-radius.c print-raw.c print-rip.c \
-	print-rsvp.c print-rx.c print-sctp.c print-sl.c \
-	print-sll.c print-smb.c print-snmp.c print-stp.c \
-	print-sunatm.c print-sunrpc.c print-tcp.c print-telnet.c \
-	print-tftp.c print-timed.c print-token.c print-udp.c \
-	print-vjc.c print-vrrp.c print-wb.c print-zephyr.c \
-	setsignal.c smbutil.c tcpdump.c util.c version.c
+	print-rsvp.c print-rx.c print-sctp.c print-sip.c print-sl.c print-sll.c \
+	print-slow.c print-snmp.c print-stp.c print-sunatm.c print-sunrpc.c \
+	print-symantec.c print-syslog.c print-tcp.c print-telnet.c print-tftp.c \
+	print-timed.c print-token.c print-udp.c print-vjc.c print-vrrp.c \
+	print-wb.c print-zephyr.c setsignal.c tcpdump.c util.c
+SRCS+=	print-smb.c smbutil.c version.c
 CLEANFILES+=	version.c
 
 CFLAGS+= -I${.CURDIR} -I${TCPDUMP_DISTDIR}
 CFLAGS+= -DHAVE_CONFIG_H -D_U_="__attribute__((unused))"
 
+CFLAGS+= -DHAVE_RES_STATE_EXT -DHAVE_NEW_RES_STATE -DUSE_GETIPNODEBY
+CFLAGS+= -DHAVE_PCAP_VERSION -UHAVE_YYDEBUG -DHAVE_GETADDRINFO -DHAVE_GETNAMEINFO
+CFLAGS+= -DHAVE_STRUCT_ETHER_ADDR
+
 .if !defined(NOINET6)
 SRCS+=	print-ip6.c print-ip6opts.c print-mobility.c \
 	print-ripng.c print-icmp6.c print-frag6.c print-rt6.c \
Index: usr.sbin/tcpdump/tcpdump/config.h
===================================================================
RCS file: /home/dcvs/src/usr.sbin/tcpdump/tcpdump/config.h,v
retrieving revision 1.3
diff -u -r1.3 config.h
--- usr.sbin/tcpdump/tcpdump/config.h	15 May 2004 12:29:42 -0000	1.3
+++ usr.sbin/tcpdump/tcpdump/config.h	18 Dec 2006 00:12:11 -0000
@@ -1,36 +1,33 @@
-/* $FreeBSD: src/usr.sbin/tcpdump/tcpdump/config.h,v 1.1.2.4 2002/07/05 11:30:32 fenner Exp $ */
-/* $DragonFly: src/usr.sbin/tcpdump/tcpdump/config.h,v 1.3 2004/05/15 12:29:42 eirikn Exp $ */
-/* This is an edited copy of the config.h generated by configure. */
-
-/* config.h.  Generated automatically by configure.  */
-/* config.h.in.  Generated automatically from configure.in by autoheader.  */
+/* config.h.  Generated by configure.  */
+/* config.h.in.  Generated from configure.in by autoheader.  */
 /* "generated automatically" means DO NOT MAKE CHANGES TO config.h.in --
  * make them to acconfig.h and rerun autoheader */
 
-/* Define as __inline if that's what the C compiler calls it.  */
-/* #undef inline */
-
-/* Define as the return type of signal handlers (int or void).  */
-#define RETSIGTYPE void
-
-/* Define if you can safely include both <sys/time.h> and <time.h>.  */
-#define TIME_WITH_SYS_TIME 1
-
 /* Define if you have SSLeay 0.9.0b with the buggy cast128. */
 /* #undef HAVE_BUGGY_CAST128 */
 
 /* Define if you enable IPv6 support */
-/* Handled by Makefile, to allow NOINET6 */
-/* #define INET6 1 */
+/* #undef INET6 */
 
 /* Define if you enable support for the libsmi. */
 /* #undef LIBSMI */
 
+/* Define if you have the <smi.h> header file.  */
+/* #undef HAVE_SMI_H */
+
 /* define if you have struct __res_state_ext */
-#define HAVE_RES_STATE_EXT 1
+/* #undef HAVE_RES_STATE_EXT */
 
 /* define if your struct __res_state has the nsort member */
-#define HAVE_NEW_RES_STATE 1
+/* #undef HAVE_NEW_RES_STATE */
+
+/*
+ * define if struct ether_header.ether_dhost is a struct with ether_addr_octet
+ */
+/* #undef ETHER_HEADER_HAS_EA */
+
+/* define if struct ether_arp contains arp_xsha */
+/* #undef ETHER_ARP_HAS_X */
 
 /* define if you have the addrinfo function. */
 #define HAVE_ADDRINFO 1
@@ -50,6 +47,9 @@
 /* define if this is a development version, to use additional prototypes. */
 /* #undef HAVE_OS_PROTO_H */
 
+/* define if <unistd.h> defines __P() */
+/* #undef HAVE_PORTABLE_PROTOTYPE */
+
 /* define if RES_USE_INET6 is defined */
 #define HAVE_RES_USE_INET6 1
 
@@ -65,6 +65,33 @@
 /* define if you have ether_ntohost() and it works */
 #define USE_ETHER_NTOHOST 1
 
+/* define if libpcap has pcap_version */
+/* #undef HAVE_PCAP_VERSION */
+
+/* define if libpcap has pcap_debug */
+/* #undef HAVE_PCAP_DEBUG */
+
+/* define if libpcap has yydebug */
+#define HAVE_YYDEBUG 1
+
+/* define if libpcap has pcap_list_datalinks() */
+#define HAVE_PCAP_LIST_DATALINKS 1
+
+/* define if libpcap has pcap_set_datalink() */
+#define HAVE_PCAP_SET_DATALINK 1
+
+/* define if libpcap has pcap_datalink_name_to_val() */
+#define HAVE_PCAP_DATALINK_NAME_TO_VAL 1
+
+/* define if libpcap has pcap_datalink_val_to_description() */
+#define HAVE_PCAP_DATALINK_VAL_TO_DESCRIPTION 1
+
+/* define if libpcap has pcap_dump_ftell() */
+#define HAVE_PCAP_DUMP_FTELL 1
+
+/* define if you have getrpcbynumber() */
+#define HAVE_GETRPCBYNUMBER 1
+
 /* define if unaligned memory accesses fail */
 /* #undef LBL_ALIGN */
 
@@ -80,14 +107,11 @@
 /* AIX hack. */
 /* #undef _SUN */
 
-/* Workaround for missing sized types */
-/* XXX this should move to the more standard uint*_t */
-/* #undef int8_t */
-/* #undef int16_t */
-/* #undef int32_t */
-/* #undef u_int16_t */
-/* #undef u_int32_t */
-/* #undef u_int8_t */
+/* Workaround for missing 64-bit formats */
+/* #undef PRId64 */
+/* #undef PRIo64 */
+/* #undef PRIx64 */
+/* #undef PRIu64 */
 
 /* Whether or not to include the possibly-buggy SMB printer */
 #define TCPDUMP_DO_SMB 1
@@ -106,88 +130,39 @@
 /* Define if you have a dnet_htoa declaration in <netdnet/dnetdb.h>.  */
 /* #undef HAVE_NETDNET_DNETDB_H_DNET_HTOA */
 
-/* The number of bytes in a char.  */
-#define SIZEOF_CHAR 1
+/* define if should drop privileges by default */
+/* #undef WITH_USER */
 
-/* The number of bytes in a int.  */
-#define SIZEOF_INT 4
+/* define if should chroot when dropping privileges */
+/* #undef WITH_CHROOT */
 
-/* The number of bytes in a long.  */
-#define SIZEOF_LONG 4
-
-/* The number of bytes in a short.  */
-#define SIZEOF_SHORT 2
+/* Define to 1 if you have the `alarm' function. */
+#define HAVE_ALARM 1
 
 /* Define to 1 if you have the `bpf_dump' function. */
 #define HAVE_BPF_DUMP 1
 
+/* Define to 1 if you have the declaration of `ether_ntohost', and to 0 if you
+   don't. */
+#define HAVE_DECL_ETHER_NTOHOST 1
+
 /* Define to 1 if you have the `ether_ntohost' function. */
 #define HAVE_ETHER_NTOHOST 1
 
+/* Define to 1 if you have the <fcntl.h> header file. */
+#define HAVE_FCNTL_H 1
+
 /* Define to 1 if you have the `getaddrinfo' function. */
-#define HAVE_GETADDRINFO 1
+/* #undef HAVE_GETADDRINFO */
 
 /* Define to 1 if you have the `getnameinfo' function. */
-#define HAVE_GETNAMEINFO 1
+/* #undef HAVE_GETNAMEINFO */
 
 /* Define to 1 if you have the <inttypes.h> header file. */
 #define HAVE_INTTYPES_H 1
 
-/* Define to 1 if you have the `pfopen' function. */
-/* #undef HAVE_PFOPEN */
-
-/* Define to 1 if you have the `setlinebuf' function. */
-#define HAVE_SETLINEBUF 1
-
-/* Define to 1 if you have the `sigaction' function. */
-#define HAVE_SIGACTION 1
-
-/* Define to 1 if you have the `sigset' function. */
-/* #undef HAVE_SIGSET */
-
-/* Define to 1 if you have the `snprintf' function. */
-#define HAVE_SNPRINTF 1
-
-/* Define to 1 if you have the `strcasecmp' function. */
-#define HAVE_STRCASECMP 1
-
-/* Define to 1 if you have the `strdup' function. */
-#define HAVE_STRDUP 1
-
-/* Define to 1 if you have the `strlcat' function. */
-#define HAVE_STRLCAT 1
-
-/* Define to 1 if you have the `strlcpy' function. */
-#define HAVE_STRLCPY 1
-
-/* Define to 1 if you have the `vfprintf' function. */
-#define HAVE_VFPRINTF 1
-
-/* Define to 1 if you have the `vsnprintf' function. */
-#define HAVE_VSNPRINTF 1
-
-/* Define if you have the <cast.h> header file.  */
-/* Handled by Makefile, to allow optional crypto */
-/* #define HAVE_CAST_H 1 */
-
-/* Define to 1 if you have the <fcntl.h> header file. */
-#define HAVE_FCNTL_H 1
-
-/* Define to 1 if you have the <netinet/if_ether.h> header file. */
-#define HAVE_NETINET_IF_ETHER_H 1
-
-/* Define to 1 if you have the <openssl/evp.h> header file. */
-#define HAVE_OPENSSL_EVP_H 1
-
-/* Define to 1 if you have the <rpc/rpcent.h> header file. */
-/* #undef HAVE_RPC_RPCENT_H */
-
-/* Define to 1 if you have the <smi.h> header file. */
-/* #undef HAVE_SMI_H */
-
-/* Define if you have the crypto library (-lcrypto).  */
-/* Handled by Makefile, to allow optional crypto */
-/* #define HAVE_LIBCRYPTO 1 */
+/* Define to 1 if you have the `crypto' library (-lcrypto). */
+#define HAVE_LIBCRYPTO 1
 
 /* Define to 1 if you have the `rpc' library (-lrpc). */
 /* #undef HAVE_LIBRPC */
@@ -195,41 +170,6 @@
 /* Define to 1 if you have the `smi' library (-lsmi). */
 /* #undef HAVE_LIBSMI */
 
-/* define if your compiler has __attribute__ */
-#define HAVE___ATTRIBUTE__ 1
-
-/*
- * define if struct ether_header.ether_dhost is a struct with ether_addr_octet
- */
-/* #undef ETHER_HEADER_HAS_EA */
-
-/* define if struct ether_arp contains arp_xsha */
-/* #undef ETHER_ARP_HAS_X */
-
-/* define if <unistd.h> defines __P() */
-/* #undef HAVE_PORTABLE_PROTOTYPE */
-
-/* define if libpcap has pcap_version */
-#define HAVE_PCAP_VERSION 1
-
-/* define if libpcap has pcap_debug */
-/* #undef HAVE_PCAP_DEBUG */
-
-/* define if libpcap has yydebug */
-/* #undef HAVE_YYDEBUG */
-
-/* define if libpcap has pcap_list_datalinks() */
-#define HAVE_PCAP_LIST_DATALINKS 1
-
-/* define if libpcap has pcap_set_datalink() */
-#define HAVE_PCAP_SET_DATALINK 1
-
-/* define if libpcap has pcap_datalink_name_to_val() */
-#define HAVE_PCAP_DATALINK_NAME_TO_VAL 1
-
-/* define if libpcap has pcap_datalink_val_to_description() */
-#define HAVE_PCAP_DATALINK_VAL_TO_DESCRIPTION 1
-
 /* Define to 1 if you have the <memory.h> header file. */
 #define HAVE_MEMORY_H 1
 
@@ -239,6 +179,12 @@
 /* Define to 1 if you have the <netinet/ether.h> header file. */
 /* #undef HAVE_NETINET_ETHER_H */
 
+/* Define to 1 if you have the <netinet/if_ether.h> header file. */
+#define HAVE_NETINET_IF_ETHER_H 1
+
+/* Define to 1 if you have the <openssl/evp.h> header file. */
+#define HAVE_OPENSSL_EVP_H 1
+
 /* Define to 1 if you have the `pcap_breakloop' function. */
 #define HAVE_PCAP_BREAKLOOP 1
 
@@ -254,12 +200,39 @@
 /* Define to 1 if you have the `pcap_lib_version' function. */
 #define HAVE_PCAP_LIB_VERSION 1
 
+/* Define to 1 if you have the `pfopen' function. */
+/* #undef HAVE_PFOPEN */
+
+/* Define to 1 if you have the <rpc/rpcent.h> header file. */
+/* #undef HAVE_RPC_RPCENT_H */
+
+/* Define to 1 if you have the `setlinebuf' function. */
+#define HAVE_SETLINEBUF 1
+
+/* Define to 1 if you have the `sigaction' function. */
+#define HAVE_SIGACTION 1
+
+/* Define to 1 if you have the `sigset' function. */
+/* #undef HAVE_SIGSET */
+
+/* Define to 1 if you have the <smi.h> header file. */
+/* #undef HAVE_SMI_H */
+
+/* Define to 1 if you have the `snprintf' function. */
+#define HAVE_SNPRINTF 1
+
 /* Define to 1 if you have the <stdint.h> header file. */
 #define HAVE_STDINT_H 1
 
 /* Define to 1 if you have the <stdlib.h> header file. */
 #define HAVE_STDLIB_H 1
 
+/* Define to 1 if you have the `strcasecmp' function. */
+#define HAVE_STRCASECMP 1
+
+/* Define to 1 if you have the `strdup' function. */
+#define HAVE_STRDUP 1
+
 /* Define to 1 if you have the `strftime' function. */
 #define HAVE_STRFTIME 1
 
@@ -269,9 +242,21 @@
 /* Define to 1 if you have the <string.h> header file. */
 #define HAVE_STRING_H 1
 
+/* Define to 1 if you have the `strlcat' function. */
+#define HAVE_STRLCAT 1
+
+/* Define to 1 if you have the `strlcpy' function. */
+#define HAVE_STRLCPY 1
+
 /* Define to 1 if you have the `strsep' function. */
 #define HAVE_STRSEP 1
 
+/* Define to 1 if the system has the type `struct ether_addr'. */
+/* #undef HAVE_STRUCT_ETHER_ADDR */
+
+/* Define to 1 if you have the <sys/bitypes.h> header file. */
+/* #undef HAVE_SYS_BITYPES_H */
+
 /* Define to 1 if you have the <sys/stat.h> header file. */
 #define HAVE_SYS_STAT_H 1
 
@@ -281,6 +266,21 @@
 /* Define to 1 if you have the <unistd.h> header file. */
 #define HAVE_UNISTD_H 1
 
+/* Define to 1 if you have the `vfprintf' function. */
+#define HAVE_VFPRINTF 1
+
+/* Define to 1 if you have the `vsnprintf' function. */
+#define HAVE_VSNPRINTF 1
+
+/* define if your compiler has __attribute__ */
+#define HAVE___ATTRIBUTE__ 1
+
+/* Define to 1 if netinet/ether.h declares `ether_ntohost' */
+/* #undef NETINET_ETHER_H_DECLARES_ETHER_NTOHOST */
+
+/* Define to 1 if netinet/if_ether.h declares `ether_ntohost' */
+#define NETINET_IF_ETHER_H_DECLARES_ETHER_NTOHOST 
+
 /* Define to the address where bug reports for this package should be sent. */
 #define PACKAGE_BUGREPORT ""
 
@@ -296,5 +296,53 @@
 /* Define to the version of this package. */
 #define PACKAGE_VERSION ""
 
+/* Define as the return type of signal handlers (`int' or `void'). */
+#define RETSIGTYPE void
+
+/* The size of a `char', as computed by sizeof. */
+#define SIZEOF_CHAR 1
+
+/* The size of a `int', as computed by sizeof. */
+#define SIZEOF_INT 4
+
+/* The size of a `long', as computed by sizeof. */
+#define SIZEOF_LONG 4
+
+/* The size of a `long long', as computed by sizeof. */
+#define SIZEOF_LONG_LONG 8
+
+/* The size of a `short', as computed by sizeof. */
+#define SIZEOF_SHORT 2
+
 /* Define to 1 if you have the ANSI C header files. */
 #define STDC_HEADERS 1
+
+/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
+#define TIME_WITH_SYS_TIME 1
+
+/* Define as token for inline if inlining supported */
+#define inline inline
+
+/* Define to `short' if int16_t not defined. */
+/* #undef int16_t */
+
+/* Define to `int' if int32_t not defined. */
+/* #undef int32_t */
+
+/* Define to `long long' if int64_t not defined. */
+/* #undef int64_t */
+
+/* Define to `signed char' if int8_t not defined. */
+/* #undef int8_t */
+
+/* Define to `unsigned short' if u_int16_t not defined. */
+/* #undef u_int16_t */
+
+/* Define to `unsigned int' if u_int32_t not defined. */
+/* #undef u_int32_t */
+
+/* Define to `unsigned long long' if u_int64_t not defined. */
+/* #undef u_int64_t */
+
+/* Define to `unsigned char' if u_int8_t not defined. */
+/* #undef u_int8_t */